#ifndef __CBRFeature__
#define __CBRFeature__

#include "string"
#include "vector"
#include "iostream"
#include "map"
using namespace std;


class CBRFeature{
public:
	CBRFeature(std::string);
	CBRFeature();
// add
	void addSimilarity(std::string, std::string, float);
	void addValue(std::string, int num);
	void setNumeric(bool);
	void setOfTypeInt(bool in) {isOfInt = in;}
	void addRange(float , float );

// get
	float getNumericalSimilarity(float, float);
	float getSimilarity(std::string, std::string);
	const std::string getName();
	bool isNumeric();
	std::vector<std::string> getAllowedValues();
	float getMin() const {return from;}
	float getMax() const {return to;}
	bool isOfTypeInt() const {return (numeric && isOfInt);}
// div
	const void PrintAllowedValues();


private:

	int getOffset(int, int);
	vector<float> similarity;
	vector<std::string> valueNames;
	vector<int> valueNums;
	map<std::string, int> Value2Num;
	std::string name;
	int match(std::string);
	bool numeric;
	bool isOfInt;
	float from;
	float to;
};

#endif