#include "CBRcase.h"
#include "string"
#include "map"


/*
	SHOULD BE DIVIDED INTO A NUMERICAL/SYMBOLICAL VIA INHERITANCE, BUT I AM LAZY.

*/

using namespace std;

/*

				SETTERS

*/
// Add an int-value to the Index named <string>
void CBRCase::SetIntIndex(std::string inName, int inValue) {
    std::map<std::string, int>::const_iterator it = intIndexes.find(inName);
//	if (it == intIndexes.end())
		intIndexes[inName] = inValue;
//	else
//		cout << inName << " is already set in case " << num;
}

// Add an float-value to the Index named <string>
void CBRCase::SetFloatIndex(std::string inName, float inValue) {
    std::map<std::string, float>::const_iterator it = floatIndexes.find(inName);
//	if (it == floatIndexes.end())
		floatIndexes[inName] = inValue;
//	else
//		cout << inName << " is already set in case " << num;
}

// Add an string-value to the Index named <string>
void CBRCase::SetStringIndex(std::string inName, std::string inValue) {
	std::map<std::string, std::string>::const_iterator it = stringIndexes.find(inName);
//	if (it == stringIndexes.end())
		stringIndexes[inName] = inValue;
//	else
//		cout << inName << " is already set in case " << num;
}

void CBRCase::SetNumber(int *a) {
	num = a;
}


/*

				GETTERS

*/

// get the int-value of the Index named <string>
int CBRCase::GetIntIndex(std::string inName) {
	std::map<std::string, int>::const_iterator it = intIndexes.find(inName);
	if(it != intIndexes.end())
		return intIndexes[inName];
	return -1;
}

// get the float-value of the Index named <string>
float CBRCase::GetFloatIndex(std::string inName) {
	std::map<std::string, float>::const_iterator it = floatIndexes.find(inName);
	if(it != floatIndexes.end())
		return floatIndexes[inName];
	return -1;
}

// get the string-value of the Index named <string>
std::string CBRCase::GetStringIndex(std::string inName) {
	std::map<std::string, std::string>::const_iterator it = stringIndexes.find(inName);
	if(it != stringIndexes.end())
		return stringIndexes[inName];
	return "-1";
}


int CBRCase::GetNumber() {
	return *num;
}



/*

						OTHERS

*/

// Method called to compare two cases. Used to find most similar case to input-case.
double CBRCase::CompareTo(CBRCase &otherCase, std::map<std::string, CBRFeature> &features) {
	double sim = 0;
	double num = 0;
	//iterate through all indexes stored in intIndexes and compare.
	CBRFeature feat;

	// error with casting int-float. Returns -1.#IND when not commented out.

	//int otherInt =0;
	//std::map<std::string, int>::const_iterator intit = intIndexes.begin();
	//for(;intit != intIndexes.end(); intit++) {
	//	otherInt = otherCase.GetIntIndex(intit->first);
	//	float a = feat.getNumericalSimilarity(otherInt, intIndexes[intit->first]);
	//	sim += a*a;
	//	num++;
	//}
	
	//go through all string indexes and compute similarity
	std::string otherString ="";

//	cout << "Size of featurelist is in compare: " << features.size() << endl;

	std::map<std::string, std::string>::const_iterator strit = stringIndexes.begin(); 
	for(;strit != stringIndexes.end(); strit++) {
		otherString = otherCase.GetStringIndex(strit->first);
		feat = features[strit->first];
		float a = feat.getSimilarity(otherString, stringIndexes[strit->first]);
		sim += a*a;
		num++;
	}
	

	// FIX FOR FLOAT AS WELL.
	float otherFloat =0;
	std::map<std::string, float>::const_iterator flit = floatIndexes.begin();
	for(;flit != floatIndexes.end(); flit++) {
		otherFloat = otherCase.GetFloatIndex(flit->first);
		feat = features[flit->first];
		float a = feat.getNumericalSimilarity(otherFloat, floatIndexes[flit->first]);
		sim += a*a;
		num++;
	}
	return sim / num;
}




/************************************************************************************************************

	Copy all information for one case to another

*************************************************************************************************************/
void CBRCase::caseCopy(CBRCase &incoming) {
	std::map<std::string, float>::const_iterator flit = floatIndexes.begin();
	std::map<std::string, int>::const_iterator iit = intIndexes.begin();
	std::map<std::string, std::string>::const_iterator sit = stringIndexes.begin();
	
	// copy floats
	for(;flit != floatIndexes.end(); flit++) {
		incoming.SetFloatIndex(flit->first, flit->second);
	}

	//copy ints
	for(;iit != intIndexes.end(); iit++) {
		incoming.SetIntIndex(iit->first, iit->second);
	}

	// copy strings
	for(;sit != stringIndexes.end(); sit++) {
		if(sit->first == "file") continue;
		incoming.SetStringIndex(sit->first, sit->second);
	}

}




//mainly debugging.
void CBRCase::Print() {
	std::map<std::string, int>::const_iterator it = intIndexes.begin();
	for(;it != intIndexes.end(); it++) {
		cout << "Int "<<it->first << ", " << it->second<<endl;
	}
	std::map<std::string, float>::const_iterator it2 = floatIndexes.begin();
	for(;it2 != floatIndexes.end(); it2++) {
		cout << "Float "<< it2->first << ", " << it2->second<<endl;
	}
	std::map<std::string, std::string>::const_iterator it3 = stringIndexes.begin();
	for(;it3 != stringIndexes.end(); it3++) {
		cout << "String "<< it3->first << ", " << it3->second<<endl;
	}
}