#include <QLCDNumber>
#include <QSlider>
#include <QVBoxLayout>

#include "lcdrange.h"

LCDRange::LCDRange(QWidget *parent)
    : QWidget(parent)
{
    QLCDNumber *lcd = new QLCDNumber(2);
    lcd->setSegmentStyle(QLCDNumber::Filled);

    slider = new QSlider(Qt::Horizontal);
    slider->setRange(0, 99);
    slider->setValue(0);

    connect(slider, SIGNAL(valueChanged(int)),
            lcd, SLOT(display(int)));
    connect(slider, SIGNAL(valueChanged(int)),
            this, SIGNAL(valueChanged(int)));

    QVBoxLayout *layout = new QVBoxLayout;
    layout->addWidget(lcd);
    layout->addWidget(slider);
    setLayout(layout);    
    
    setFocusProxy(slider);
}

void LCDRange::setRange(int minValue, int maxValue) {
    if(minValue <0 || maxValue > 99 || minValue > maxValue) {
    qWarning("LCDRange::setRange(%d, %d) \n"
        "\tRange must be 0..99\n"
        "\tand minValue must be smaller than maxValue",
        minValue, minValue);
    return;
    }
    slider->setRange(minValue, maxValue);
}

void LCDRange::setValue(int value)
{
    slider->setValue(value);
}

int LCDRange::value() const
{
    return slider->value();
}


