#include <vector>
#include <map>
#include <iostream>     
#include <sstream>     
#include <iomanip>


#include "xml2cbr.h"
#include "tinyxml.h"
#include "tinystr.h"
#include "CBRcase.h"
#include "CBRFeature.h"
#include "CBRitk.h"
#include "itkImage.h"


//COPIED FROM INTERNET --- START
// http://www.codeguru.com/forum/showthread.php?s=&threadid=231054
template <class T>
bool from_string(T& t, 
                 const std::string& s, 
                 std::ios_base& (*f)(std::ios_base&))
{
  std::istringstream iss(s);
  return !(iss >> f >> t).fail();
}
 // COPIED FOR INTERNET --- END


xml2cbr::xml2cbr() {
	;
}


void xml2cbr::LoadCasesFromXML() {

		// FIKS HARDKODING
    TiXmlDocument doc("test.xml");
    if(!doc.LoadFile()) {
	    printf("Error loading test.xml, start of loadCases\n");
    }
    
    TiXmlElement *index;
    TiXmlHandle handle(&doc);
	

	//use handle and bind values to this map
	//the index-types should be moved and defined in DK.xml
	loadIndexTypesFromXML(&indexTypes, &handle);
	


    TiXmlElement * CBRCaseXML = handle.FirstChild("caseLibrary").FirstChild("cases").FirstChild("case").ToElement();
	CBRCase * caseFromFile = 0;

	//error variable
	int check = 0;
	if(CBRCaseXML) {
        // loop CBRCase
        while(CBRCaseXML != 0) {

			// read in indexes as they are named in the map indexMap
			std::map<std::string, int>::const_iterator it = indexTypes.begin();

			//first index
			std::string indexName = it->first;
			index = CBRCaseXML->FirstChild("indexes")->FirstChild(indexName.c_str())->ToElement();

			// save values from file in this, and save to cases-vector
			caseFromFile = new CBRCase();
			int *a = new int;
			*a = 0;

		
			//	extract number from case
			check = CBRCaseXML->QueryIntAttribute("num", a);
 
			if(check == TIXML_WRONG_TYPE) {
				printf("Num not an int in Case %s", CBRCaseXML->Attribute("num"));
			}
			else if(check == TIXML_NO_ATTRIBUTE) {
				printf("No attribute \"num\" in case.");
			}
			caseFromFile->SetNumber(a);
         
			// loop index and get attributes
			int tmpAttrInt = 0;
			float tmpAttrFloat = 0.0;
			std::string tmpString = "";
			if(index) {
				while(index != 0) {
					switch(indexTypes[indexName]) {
					 case 0: // int
						 tmpString = index->GetText();
						 from_string<int>(tmpAttrInt, tmpString, std::dec);
						 caseFromFile->SetIntIndex(indexName, tmpAttrInt);
						 //cout << "satte " <<indexName<<" til "<<tmpAttrInt<< " as int i case "<<caseFromFile->GetNumber()<<endl;
						 break;
					 case 1: // float
						 tmpString = index->GetText();
						 from_string<float>(tmpAttrFloat, tmpString, std::dec);
						 caseFromFile->SetFloatIndex(indexName, tmpAttrFloat);
						 //cout << "satte " <<indexName<<" til "<<tmpAttrFloat<< " as float i case "<<caseFromFile->GetNumber()<<endl;
						 break;
					 case 2:
						 tmpString = index->GetText();
						 caseFromFile->SetStringIndex(indexName, tmpString);
						 // cout << "satte " <<indexName<<" til "<<tmpString<< " as string i case "<<caseFromFile->GetNumber()<<endl;
						 break;

					 default:
						 cout << "Error, indexType of unknown type"<< " i case "<<caseFromFile->GetNumber()<<endl;
					}
						
					// next index		
				it++;
				if(it == indexTypes.end()) {index = 0; continue;}
				indexName = it->first;
				index = CBRCaseXML->FirstChild("indexes")->FirstChild(indexName.c_str())->ToElement();
			 } // while
			}  //if
		//save the class CBRCase 
		cases.push_back(*caseFromFile);

		//get next case
		CBRCaseXML = CBRCaseXML->NextSiblingElement();
        }
        
    }
	else {cout << "feil";}
//	delete index;
	}






//responsible for  sette opp CBRFeatures
	void xml2cbr::LoadDomainKnowledgeFromXML() {
	CBRFeature *feature = 0;
	TiXmlDocument doc("DK.xml");

	//first, read and parse the different attributes and their legal values
    if(!doc.LoadFile()) {
		printf("Error loading DK.xml\n");
    }
    TiXmlHandle handle(&doc);
    TiXmlElement * featureXML = handle.FirstChild("DomainKnowledge").FirstChild("FeatureValues").FirstChild("Feature").ToElement();
    if(featureXML) {


		//loop over Feature - elements
		while(featureXML != 0) {			
			std::string name = featureXML->Attribute("name");
			 feature = new CBRFeature(name);            
        
			 // if feature of type symbol the allowed types must be saved
            if(strcmp(featureXML->Attribute("type"), "symbol") == 0) {
                 TiXmlElement * fValue = featureXML->FirstChildElement("FeatureValue");
				feature->setNumeric(false);
				 // new feature

				// loop allowed values
                 while(fValue != 0 ) {
//                      cout << "\t" << fValue->GetText() << endl;
						// need a pointer to int to extract attribute value
					  int *a = new int;
						*a = 0;
						int check = fValue->QueryIntAttribute("num" , a);
						
					if(check == TIXML_WRONG_TYPE) {
						printf("Num not an int in Feature %s", fValue->Attribute("num"));
					}	
					else if(check == TIXML_NO_ATTRIBUTE) {
						cout << "No attribute \"num\" in feature "<<name<< endl;
					}
						
						// save to feature
//					const char* tmp = fValue->GetText();
					std::string tmp2 = fValue->GetText();//tmp;
					  feature->addValue(tmp2, *a);
//						delete a;
                      //get next allowed value
                      fValue = fValue->NextSiblingElement();
                 }
			}
            else if(strcmp(featureXML->Attribute("type"), "float") == 0) {
				feature->setNumeric(true);
				feature->setOfTypeInt(false);
			}
			else {
				feature->setNumeric(true);
				feature->setOfTypeInt(true);
			}
            // save the CBRFeature to list
			 features[name] = (*feature);

			 cout << "added " <<name <<" to feature list"<<endl;
            
            // get next feature
            featureXML = featureXML->NextSiblingElement();
        }

    }
    else {
        cout << "feil";
    }  

//		LoadMappingFromXML(&handle);
//		LoadIntRanges(handle);
//		LoatFloatRanges(handle);
}


void xml2cbr::LoadMappingFromXML(TiXmlHandle *handle) {
	// parse and save values
	CBRFeature *feature;
	TiXmlElement * map=0;
	TiXmlElement * Symbols =  handle->FirstChild("DomainKnowledge").FirstChild("SymbolMapping").FirstChild("Symbol").ToElement();
	if(!Symbols) {
		cout << "Feil ved lesing av symboler"  <<endl;
	}
	while(Symbols != 0) {
		// iterate all Symbols
		const char * tmp = Symbols->Attribute("name");
		std::string	symbolName = tmp;

		// find correct CBRFeature for this name from Symbol
//		for(unsigned int i = 0;	i<features.size(); i++)	{
////			std::string fname = features[i].getName();
//			if((features[i].getName()).compare(symbolName) == 0)	{
//				feature = &(features[i]);
//				break;
//			}
//		}
		feature = &(features[symbolName]);

		// we have correct feature, iterate through all <map> and record similarity
		map = Symbols->FirstChildElement("Map");

		while(map != 0) {
			// a lot of casting..
			const char * toChar = map->Attribute("to");
			const char * fromChar = map->Attribute("from");
			const char * simChar = map->GetText();
			std::string to = toChar;
			std::string from = fromChar;
			std::string simS = simChar;
			float sim = 0.0;
			from_string<float>(sim, simS, std::dec);
			feature->addSimilarity(to, from, sim);
			map = map->NextSiblingElement();
		}

		Symbols = Symbols->NextSiblingElement();
	} // while Symbols != 0

}






//iterate through <caseLibrary><indexDefinitions><Definiton> here </></></>
//and save to map.
//0 = int, 1 = float, 2 = text
void xml2cbr::loadIndexTypesFromXML(map<std::string, int> * indexMap, TiXmlHandle* handle) {
	TiXmlElement * Def = handle->FirstChild("caseLibrary").FirstChildElement("indexDefinitions").FirstChildElement("Definition").ToElement();
	if(!Def) {
		cout << "Error reading indexDefinitions";
	}
	std::string typeS = "";
	std::string name = "";
	int type = -1;
	while(Def != 0) {

		//get type of index
		typeS = Def->Attribute("type");
		if(typeS.compare("symbol") == 0)
			type = 2;
		else if(typeS.compare("float") == 0)
			type = 1;
		else // integer
			type = 0;
		
		//get name of index
		name = Def->GetText();

		// save type filed under index. Simple error checking
		map<std::string, int>::const_iterator it = indexMap->find(name);
		if(it != indexMap->end() ) {
			cout << "Index " << name<<" already defined as "<< (*indexMap)[name];
		
		//  jump to next Definition
			Def = Def->NextSiblingElement();
			continue;
		}
		// save the type 
		(*indexMap)[name] = type;
//		cout << "satte " <<name<< " til type "<<type<<endl;
		

		// next Definition	
		Def = Def->NextSiblingElement();
	}
}


void xml2cbr::LoadIntRanges(TiXmlHandle & handle) {

	CBRFeature *feature;
	TiXmlElement * Ints =  handle.FirstChild("DomainKnowledge").FirstChild("IntRanges").FirstChild("Range").ToElement();
	if(!Ints) {
		cout << "Feil ved lesing av Integers, DK.xml"  <<endl;
	}
	while(Ints != 0) {
		// iterate all Symbols
		std::string IntName = Ints->GetText();
		
		//get CBRFeature with this name
		feature = &(features[IntName]);

		//read and parse To, From from XML file
		float to=0;
		float from=0;
		std::string intTemp = Ints->Attribute("from");
		from_string<float>(from, intTemp, std::dec);
		intTemp = Ints->Attribute("to");
		from_string<float>(to, intTemp, std::dec);

		// save to CBRfeature
		feature->addRange(from, to);

		//get ned <Range int>
		Ints = Ints->NextSiblingElement();
	}
}

//reads all <Range> under <FloatRange> in DK.xml
void xml2cbr::LoatFloatRanges(TiXmlHandle & handle) {

	CBRFeature * feature;
	TiXmlElement * Floats = handle.FirstChild("DomainKnowledge").FirstChild("FloatRanges").FirstChild("Range").ToElement();
	if(!Floats) {
		cout << "Feil ved lesing av Float, DK.xml"<<endl;
	}
	else{
		
		//iterate over floats
		while(Floats != 0) {
		
		// get name of float
		std::string floatName = Floats->GetText();
		
		//get and parse values
		float from=0;
		float to=0;
		std::string tmp = Floats->Attribute("from");
		from_string<float>(from, tmp, std::dec);
		tmp = Floats->Attribute("to");
		from_string<float>(to, tmp, std::dec);
		
		
		//get correct CBRFeature and save values there
		feature = &(features[floatName]);
		feature->addRange(from, to);


		// Next Float
		Floats = Floats->NextSiblingElement();
		}
	}
}


void  xml2cbr::addIndexToNewCase(std::string Iname, std::string Vname) {
//	std::cout << "Incoming: " << Iname << " og " << Vname << " type " << indexTypes[Iname] << std::endl;
	switch(indexTypes[Iname]) {
					 case 0: // int
						 int tmpAttrInt;
						 from_string<int>(tmpAttrInt, Vname, std::dec);
						 newCase.SetIntIndex(Iname, tmpAttrInt);
						 //cout << "satte " <<Iname<<" til "<<tmpAttrInt<< " as int i input case "<<endl;
						 break;
					 case 1: // float
						 float tmpAttrFloat;
						 from_string<float>(tmpAttrFloat, Vname, std::dec);
						 newCase.SetFloatIndex(Iname, tmpAttrFloat);
						 //cout << "satte " <<Iname<<" til "<<tmpAttrFloat<< " as float i input case "<<endl;
						 break;
					 case 2:
						 newCase.SetStringIndex(Iname, Vname);
//						 cout << "satte " <<Iname<<" til "<<Vname<< " as string i input case "<<endl;
						 break;

					 default:
						 cout << "Error, indexType of unknown type in input case; "<<Iname<<endl;
	}	
}


///************************************************************************************************
//
//	The matching function.
//
//************************************************************************************************/
//void xml2cbr::match() {
//	double best = 100000;
//	int bestint = 0;
//	for(unsigned int i = 0; i<cases.size(); i++) {
//		double comp = (cases[i]).CompareTo(newCase, features);
//		if(comp < best) {
//			best = comp;
//			bestint = i;
//		}
//		cout << "new case vs "<<cases[i].GetNumber()<<" - "<< (cases[i]).CompareTo(newCase, features)<<endl;
//	 }
//	bestCase = cases[bestint];
//}


/************************************************************************************************

	The matching function.

************************************************************************************************/
void xml2cbr::match() {
	//bestCase = MatchCases(cases, newCase); //--thiss
	//ProcessCase(bestCase, newCase); //- thiss
//	bestCase = MatchCases(cases, newCase);
////	ProcessCase(bestCase, newCase);


//	ProcessCase(cases[0], newCase);
	//bestCase = MatchCases(cases, newCase);
	//ProcessCase(bestCase, newCase);

	BruteLast(cases);

}

void xml2cbr::quickmatch() {
	QuickMatch(newCase, cases);
	exit(1);
}






//adds this new case to the xml-file containing all cases.
void xml2cbr::saveNewCaseToXML() {
	
	//read the file and make the tree
	TiXmlDocument doc("test.xml");
    if(!doc.LoadFile()) {
	    printf("Error loading test.xml in saveNewCaseToXML");
		exit(1);
	}
	TiXmlPrinter printer;
	printer.SetIndent("\t");

	//build new <case> tree, add to doc later
	TiXmlElement newElem("case");
	newElem.SetAttribute("num", cases.size()+1);
	
	// new <indexes>
	TiXmlElement indexesElem("indexes");

	//new <indexName1><indexName2>...
	map<std::string, int>::const_iterator iter;
	for(iter=indexTypes.begin(); iter!=indexTypes.end(); iter++) {
//		TiXmlElement *index = new TiXmlElement(iter->first);

		//simple error checking
		if(iter->second < 0 || iter->second > 2) {
			cout << "Error with index type of " <<iter->first <<" in saveNewCaseToXML "<<endl;
			exit(1);
		}

		TiXmlElement index(iter->first);

		//get the feature value in string if it is int or float
		string inn = "";
		if(iter->second ==2)
			inn = iter->first;
		else
			inn = convertFeatureValueToString(iter->second, iter->first, 0);
			// called with 0 for newCase.


		if(inn.compare("error") == 0) {
			cout << "error returned from converting feature value to string."<<endl;
			exit(1);
		}

		// create the stuff between <featureName> and </featureName>
		TiXmlText text(inn);
		index.InsertEndChild(text);

	 
	indexesElem.InsertEndChild(index);
	}

	// add <indexes> to <case>
	newElem.InsertEndChild(indexesElem);

	//get the <cases> element to add the new case at the end.
	TiXmlHandle handle(&doc);
    TiXmlElement * casesElem = handle.FirstChild("caseLibrary").FirstChild("cases").ToElement();

	//add <case> to <cases>
	casesElem->InsertEndChild(newElem);

	doc.Accept(&printer);
	cout << printer.CStr() << endl;
}



// used by PLogic to get the values needed to build the match-window. 
//casee = 0 indicates we want to get values from the newCase
string xml2cbr::getFeatureValue(string feat, int const casee) {

	int type = 0;
	string returnString = "";
	
	//casee = 0 indicates we want to get values from the newCase
		type = getIndexType(feat);
		if(type == -1){
			cout << "Fatal Error. Can not associate "<<feat<<" with type of index"<<endl;
			exit(1);
		}
		// type of int or float, needs to be casted.
		else if(type == 0 || type == 1) {
			returnString = convertFeatureValueToString(type, feat, casee);

			// check to see if value is valid
			if(returnString.compare("error") == 0) {
				cout << "error returned from converting feature value to string in getFeatureValue."<<endl;
				exit(1);
			}
			return returnString;
		}
		// feature is of string, just return
		if(casee == 0)
			return newCase.GetStringIndex(feat);
		else
			return bestCase.GetStringIndex(feat);
}



int xml2cbr::getIndexType(string name) {
	map<std::string, int>::const_iterator iter;
	for(iter=indexTypes.begin(); iter!=indexTypes.end(); iter++) {
		if(name.compare(iter->first) == 0)
			return iter->second;
	}
	return -1;
}



//type - type of attribute, name - name of feature, casee: 0= newCase, alt annet er bestCase
string xml2cbr::convertFeatureValueToString(int type, string name, int casee) {
	if(type == 0) {
				// a lot of problem to cast.
				int in;
				if(casee == 0)
					in = newCase.GetIntIndex(name);
				else 
					in = bestCase.GetIntIndex(name);
				stringstream ss;
				ss << in;
				string inn;
				ss >> inn;
				return inn;
		}
		else if(type == 1) { //float
				// a lot of problem to cast.
				float  in;
				if(casee == 0)
					in= newCase.GetFloatIndex(name);
				else
					in = bestCase.GetFloatIndex(name);
				ostringstream ostr ;
				ostr << setprecision ( 4 ) << in ;     
				string inn ( ostr.str () ) ;
				return inn;
		}
		return "error";
}


// In order for the input window to show all cases, 
// return the name of them.. 
// iterates through the cases-vector and stores the names
std::vector<std::string> xml2cbr::getCaseNames() {
	std::vector<std::string> retVector;

	// 1_24 etc is saved in feature "file"
	for(unsigned int i  = 0; i< cases.size(); i++) {
		retVector.push_back(cases[i].GetStringIndex("file"));
	}

	return retVector;
}


// take the "file" from the newCase and find the cbr-case that 
// matches this "file". Then use the solution.
void xml2cbr::useNewCaseAsOld() {
	std::string toFind = newCase.GetStringIndex("file");
	
	//find the correct CBRCase
	CBRCase toUse;
	for(unsigned int i = 0; i <  cases.size() ; i++) {
		if(toFind == cases[i].GetStringIndex("file")) {
			toUse = cases[i];
			break;
		}
	}

	//toUse.Print();
	//std::cout << "Case found, using: " << toUse.GetStringIndex("file") << std::endl ;
	
	typedef itk::Image<int, 3> T;
	UseThreshold<T>(toUse, "old", 99);
}
