#ifndef __XML2CBR_H
#define __XML2CBR_H


#include <map>
#include "tinyxml.h"
#include "tinystr.h"
#include "CBRcase.h"
#include "CBRFeature.h"

class xml2cbr {

public: 
	void LoadCasesFromXML();
	void LoadDomainKnowledgeFromXML();
	void saveNewCaseToXML();
	void addIndexToNewCase(std::string, std::string);
	void match();
	void quickmatch();

	//returns the value of the feature named feat. Casee = 0 er newcase, alt annet bestcase.
	string getFeatureValue(string feat, int casee);
	std::map<std::string, CBRFeature> getFeatures() {return features;}
	xml2cbr();

	// gets the file name of the cases. 1_24 etc. 
	std::vector<std::string> xml2cbr::getCaseNames();

	// just treats the new case as an old.
	// finds the similar case and executes the solution whitin it
	void useNewCaseAsOld();


private:

	string convertFeatureValueToString(int, string,int);
	void LoadMappingFromXML(TiXmlHandle *);

	//iterate through <caseLibrary><indexDefinitions><Definiton> here </></></> and save to map.
	// called from LoadCases
	void loadIndexTypesFromXML(map<std::string, int> * , TiXmlHandle* );

	void LoadIntRanges(TiXmlHandle & );

	//reads all <Range> under <FloatRange> in DK.xml
	void LoatFloatRanges(TiXmlHandle & );

	//returns 0-int, 1-float, 2-string.
	int getIndexType(string name);

		
		//Members

	//holds what type of index this string is. 0=int, 1=float, 2=string.
	map<std::string, int> indexTypes;

	// the case input from the GUI-windows
	CBRCase newCase;

	// set after the match() call
	CBRCase bestCase;

	std::vector<CBRCase> cases;
	std::map<std::string, CBRFeature> features;

};

#endif